
TYPO3.Flow - Bug # 56601

Major Feature # 56602 (New): Handling Of Multi Identity Entities

Status: Under Review Priority: Must have
Author: Carsten Bleicker Category:
Created: 2014-03-06 Assigned To:
Updated: 2015-02-16 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git 2.0
Subject: PersistenceManager wrong handling of ORM\Id
Description

Having this to make id unique in combination with workspace to have client entities (in german it calls "mandantenfähig"):
https://gist.github.com/pumatertion/9388169#file-cliententity-php-L22
https://gist.github.com/pumatertion/9388169#file-cliententity-php-L29

Doctrine allows composite keys: http://docs.doctrine-project.org/en/2.0.x/tutorials/composite-primary-keys.html
Wich is the sample above.

The PerstistenceManager having getIdentifierByObject() but this result is not usable by getObjectByIdentifier()
for entities having composite primary keys.

See comments:
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L184
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L222

Imho there is no need to manipulate the results of doctrine in the persistence. This is "just persistence" 
if identifier is an array wich x or y items has to be handled somewhere else as in the persistence. this should be realy get
removed from the persistence layer.

To use Flow "fearless" its essential for me that doctrine persistence delivers expected results as doctrine documented it and does not
any manupalation of datatypes, like the current() did it in 
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L200.
Currently features of Doctrine are reduces by Flows PersistenceManager.

To receive third party data wich needs to be stored with client AND id information, f.e. to handle a multiclient rest api deals with the
clientside identity flow makes realy problems doing this because you expect that doctrine persistence acts like doctrine, but it doesnt.
But thats exactly what is Flow build for, i think.

Do you aggree?

Kind Regards
carsten bleicker

History
#1 - 2014-03-06 13:27 - Christian Müller
- Parent task set to #56602

#2 - 2014-03-07 19:37 - Gerrit Code Review

2015-08-04 1/2

https://gist.github.com/pumatertion/9388169#file-cliententity-php-L22
https://gist.github.com/pumatertion/9388169#file-cliententity-php-L29
http://docs.doctrine-project.org/en/2.0.x/tutorials/composite-primary-keys.html
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L184
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L222
https://gist.github.com/pumatertion/9388169#file-persistencemanager-php-L200


- Status changed from New to Under Review

Patch set 4 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/26737

#3 - 2014-03-07 19:50 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/26737

#4 - 2014-12-14 11:21 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/26737

#5 - 2015-02-16 17:37 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/26737

#6 - 2015-02-16 17:56 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/26737
